let hasStim=false;
let modeStim=1;
let pression=0;


function keyDown(e) {
	if (e.repeat) {return false}
	if (e.code=="Space") {stimule()}
}

function stimule() {
	if (modeStim==0) {return false}
	hasStim=true;
}

function selectStimu (n) {
	modeStim=n;
	byId("divSelectStim"+n).classList.add("selectStimSelected");
	byId("divSelectStim"+(1-n)).classList.remove("selectStimSelected");
	if (n==1) {
		divElStim0.style.opacity=0.5;
		divElStim1.style.opacity=0.5;
		hide(divElStimM);
		hide(divElStimM1);
		hide(divElStimM2);
		show(butStim);
		hide(divChangePression);
	} else {
		divElStim0.style.opacity=0;
		divElStim1.style.opacity=0;
		show(divElStimM);
		show(divElStimM1);
		show(divElStimM2);
		hide(butStim);
		show(divChangePression);
		serreRecepteur(0);
	}
	traceFils();
}

function traceFils () {
	let dElec=byId("divElectrodes"+nElec);
	let rElec=dElec.getBoundingClientRect();
	let rInput1=divEntree1.getBoundingClientRect();
	let rInput2=divEntree2.getBoundingClientRect();
	let rMain=divFils.getBoundingClientRect();
	let l=rMain.width;
	let h=rMain.height;
	let u=rElec.width;
	let x1=rInput1.left-rMain.left+rInput1.width/2;
	let x2=rInput2.left-rMain.left+rInput2.width/2;
	let yInput=rInput1.top-rMain.top+rInput1.height/2;
	let xElec0=rElec.left+u*0.13-rMain.left;
	let yElec0=rElec.top-rMain.top+u*0.3;
	let xElec1=rElec.left+u*0.72-rMain.left;
	let yElec1=rElec.top-rMain.top-u*0.0;
	canvFils.width=rMain.width;
	canvFils.height=rMain.height;
	let ctx = canvFils.getContext('2d');
	ctx.strokeStyle="#999";
	ctx.beginPath();
	if (nElec<3) {
		ctx.moveTo(xElec1,yElec1);
		ctx.lineTo(xElec1,h*0.64);
		ctx.lineTo(x2,h*0.64);
		ctx.lineTo(x2,yInput);
		
		ctx.moveTo(xElec0,yElec0);
		ctx.lineTo(xElec0,h*0.62);
		ctx.lineTo(x1,h*0.62);
		ctx.lineTo(x1,yInput);
	} else  {
		ctx.moveTo(xElec0,yElec0);
		ctx.lineTo(xElec0,h*0.64);
		ctx.lineTo(x1,h*0.64);
		ctx.lineTo(x1,yInput);
		
		ctx.moveTo(xElec1,yElec1);
		ctx.lineTo(xElec1,h*0.62);
		ctx.lineTo(x2,h*0.62);
		ctx.lineTo(x2,yInput);
	}
	ctx.stroke();
	
	// stimulation
	let rElec0=divElStim0.getBoundingClientRect();
	let rElec1=divElStim1.getBoundingClientRect();
	let rElecM=divElStimM.getBoundingClientRect();
	let yElec;
	rInput1=divSortie1.getBoundingClientRect();
	rInput2=divSortie2.getBoundingClientRect();
	if (modeStim=="1") {
		xElec1=rElec0.left-rMain.left+rElec0.width/2;
		yElec=rElec0.bottom-rElec0.height-rMain.top;
		xElec0=rElec1.left-rMain.left+rElec1.width/2;
		x1=rInput2.left-rMain.left+rInput1.width/2;
		x2=rInput1.left-rMain.left+rInput2.width/2;
		divConsignesStim.innerHTML="Cliquer sur le bouton \"Stimuler\" ou appuyer sur la barre d'espace pour engendrer un potentiel d'action au niveau de la paire d'électrodes grises.";
		divConsignesStim.innerHTML+="<br><br>Pour générer un train de potentiel d'actions, cliquer ou appuyer plusieurs fois.";
	} else {
		xElec0=rElecM.left-rMain.left+rElecM.width*0.7;
		xElec1=rElecM.left-rMain.left+rElecM.width*0.3;
		yElec=rElecM.bottom-rElecM.height-rMain.top;	
		x1=rInput2.left-rMain.left+rInput2.width/2;
		x2=rInput1.left-rMain.left+rInput1.width/2;		
		divConsignesStim.innerHTML="A l'aide du curseur ci-dessous, modifier la pression mécanique exercée sur le récepteur sensoriel.";
		divConsignesStim.innerHTML+="<br><br><span style='opacity:0.5'>Remarque : dans la réalité ce type de récepteur est plus souvent phasique. Pour simplifier la modélisation, son comportement est ici tonique.</span>";
	}

	ctx.beginPath();
	ctx.moveTo(xElec0,yElec);
	ctx.lineTo(xElec0,h*0.6);
	ctx.lineTo(x1,h*0.6);
	ctx.lineTo(x1,yInput);
	
	ctx.moveTo(xElec1,yElec);
	ctx.lineTo(xElec1,h*0.58);
	ctx.lineTo(x2,h*0.58);
	ctx.lineTo(x2,yInput);
	
	ctx.stroke();
}

function changePression (v) {
	pression=rangePression.value;
	serreRecepteur(pression);
}

function serreRecepteur (intens) {
	let h=23*(1-intens);
	divRecepteur.style.height=h+"%";
	divElStimM1.style.bottom=61.5-intens*11.5+"%";
	divElStimM2.style.top=61.5-intens*11.5+"%";
}